//  Copyright PrimeObjects Software Inc. and other contributors <https://www.primeobjects.com/>
//
//  This source code is licensed under the MIT license.
//  The detail information can be found in the LICENSE file in the root directory of this source tree.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect } from "react";
import { isNil } from "lodash";
import { useResizeDetector } from "react-resize-detector";
export var ResizeDetectorDiv = function (props) {
    var onResize = props.onResize, children = props.children;
    var _a = useResizeDetector(), width = _a.width, height = _a.height, ref = _a.ref;
    useEffect(function () {
        if (!isNil(width) && !isNil(height))
            onResize(width, height);
    }, [width, height]);
    return (React.createElement("div", __assign({ ref: ref }, props), children));
};
export default ResizeDetectorDiv;
